/*----- PROTECTED REGION ID(KeithleyElectrometersClass.cpp) ENABLED START -----*/
static const char *RcsId      = "$Id:  $";
static const char *TagName    = "$Name:  $";
static const char *CvsPath    = "$Source:  $";
static const char *SvnPath    = "$HeadURL:  $";
static const char *HttpServer = "http://www.esrf.eu/computing/cs/tango/tango_doc/ds_doc/";
//=============================================================================
//
// file :        KeithleyElectrometersClass.cpp
//
// description : C++ source for the KeithleyElectrometersClass.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the KeithleyElectrometers once per process.
//
// project :     Keithley Electrometer
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <tango.h>
#include <KeithleyElectrometers.h>
#include <KeithleyElectrometersClass.h>

/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometersClass.cpp

//-------------------------------------------------------------------
/**
 *	Create KeithleyElectrometersClass singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_KeithleyElectrometers_class(const char *name) {
		return KeithleyElectrometers_ns::KeithleyElectrometersClass::init(name);
	}
}

namespace KeithleyElectrometers_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
KeithleyElectrometersClass *KeithleyElectrometersClass::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		KeithleyElectrometersClass::KeithleyElectrometersClass(string &s)
 * description : 	constructor for the KeithleyElectrometersClass
 *
 * @param s	The class name
 */
//--------------------------------------------------------
KeithleyElectrometersClass::KeithleyElectrometersClass(string &s):Tango::DeviceClass(s)
{
	cout2 << "Entering KeithleyElectrometersClass constructor" << endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(KeithleyElectrometersClass::constructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometersClass::constructor

	cout2 << "Leaving KeithleyElectrometersClass constructor" << endl;
}

//--------------------------------------------------------
/**
 * method : 		KeithleyElectrometersClass::~KeithleyElectrometersClass()
 * description : 	destructor for the KeithleyElectrometersClass
 */
//--------------------------------------------------------
KeithleyElectrometersClass::~KeithleyElectrometersClass()
{
	/*----- PROTECTED REGION ID(KeithleyElectrometersClass::destructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometersClass::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		KeithleyElectrometersClass::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
KeithleyElectrometersClass *KeithleyElectrometersClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new KeithleyElectrometersClass(s);
		}
		catch (bad_alloc &)
		{
			throw;
		}
	}
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		KeithleyElectrometersClass::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
KeithleyElectrometersClass *KeithleyElectrometersClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		RangeUPClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *RangeUPClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "RangeUPClass::execute(): arrived" << endl;
	((static_cast<KeithleyElectrometers *>(device))->range_up());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		RangeDOWNClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *RangeDOWNClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "RangeDOWNClass::execute(): arrived" << endl;
	((static_cast<KeithleyElectrometers *>(device))->range_down());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		AutoRangeONClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AutoRangeONClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AutoRangeONClass::execute(): arrived" << endl;
	((static_cast<KeithleyElectrometers *>(device))->auto_range_on());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		AutoRangeOFFClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AutoRangeOFFClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AutoRangeOFFClass::execute(): arrived" << endl;
	((static_cast<KeithleyElectrometers *>(device))->auto_range_off());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		ZeroCheckONClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ZeroCheckONClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "ZeroCheckONClass::execute(): arrived" << endl;
	((static_cast<KeithleyElectrometers *>(device))->zero_check_on());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		ZeroCheckOFFClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ZeroCheckOFFClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "ZeroCheckOFFClass::execute(): arrived" << endl;
	((static_cast<KeithleyElectrometers *>(device))->zero_check_off());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		ZeroCorrectONClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ZeroCorrectONClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "ZeroCorrectONClass::execute(): arrived" << endl;
	((static_cast<KeithleyElectrometers *>(device))->zero_correct_on());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		ZeroCorrectOFFClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ZeroCorrectOFFClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "ZeroCorrectOFFClass::execute(): arrived" << endl;
	((static_cast<KeithleyElectrometers *>(device))->zero_correct_off());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		AutoZeroONClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AutoZeroONClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AutoZeroONClass::execute(): arrived" << endl;
	((static_cast<KeithleyElectrometers *>(device))->auto_zero_on());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		AutoZeroOFFClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AutoZeroOFFClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AutoZeroOFFClass::execute(): arrived" << endl;
	((static_cast<KeithleyElectrometers *>(device))->auto_zero_off());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		SetAmperMeterModeClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *SetAmperMeterModeClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "SetAmperMeterModeClass::execute(): arrived" << endl;
	((static_cast<KeithleyElectrometers *>(device))->set_amper_meter_mode());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		SetVoltMeterModeClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *SetVoltMeterModeClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "SetVoltMeterModeClass::execute(): arrived" << endl;
	((static_cast<KeithleyElectrometers *>(device))->set_volt_meter_mode());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		SetOhmMeterModeClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *SetOhmMeterModeClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "SetOhmMeterModeClass::execute(): arrived" << endl;
	((static_cast<KeithleyElectrometers *>(device))->set_ohm_meter_mode());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		SetCoulombMeterModeClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *SetCoulombMeterModeClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "SetCoulombMeterModeClass::execute(): arrived" << endl;
	((static_cast<KeithleyElectrometers *>(device))->set_coulomb_meter_mode());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		ClearRegistersClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ClearRegistersClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "ClearRegistersClass::execute(): arrived" << endl;
	((static_cast<KeithleyElectrometers *>(device))->clear_registers());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		AverageStateONClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AverageStateONClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AverageStateONClass::execute(): arrived" << endl;
	((static_cast<KeithleyElectrometers *>(device))->average_state_on());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		AverageStateOFFClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AverageStateOFFClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AverageStateOFFClass::execute(): arrived" << endl;
	((static_cast<KeithleyElectrometers *>(device))->average_state_off());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		ClearBufferClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ClearBufferClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "ClearBufferClass::execute(): arrived" << endl;
	((static_cast<KeithleyElectrometers *>(device))->clear_buffer());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		StartClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *StartClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "StartClass::execute(): arrived" << endl;
	((static_cast<KeithleyElectrometers *>(device))->start());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		ResetClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ResetClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "ResetClass::execute(): arrived" << endl;
	((static_cast<KeithleyElectrometers *>(device))->reset());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		AbortClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AbortClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AbortClass::execute(): arrived" << endl;
	((static_cast<KeithleyElectrometers *>(device))->abort());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		EnableSRQBufferFullClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *EnableSRQBufferFullClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "EnableSRQBufferFullClass::execute(): arrived" << endl;
	((static_cast<KeithleyElectrometers *>(device))->enable_srqbuffer_full());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		DisableSRQBufferFullClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *DisableSRQBufferFullClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "DisableSRQBufferFullClass::execute(): arrived" << endl;
	((static_cast<KeithleyElectrometers *>(device))->disable_srqbuffer_full());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		GetKeithleyConfigClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetKeithleyConfigClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "GetKeithleyConfigClass::execute(): arrived" << endl;
	return insert((static_cast<KeithleyElectrometers *>(device))->get_keithley_config());
}

//--------------------------------------------------------
/**
 * method : 		GetRangeClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetRangeClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "GetRangeClass::execute(): arrived" << endl;
	return insert((static_cast<KeithleyElectrometers *>(device))->get_range());
}

//--------------------------------------------------------
/**
 * method : 		SetRangeClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *SetRangeClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "SetRangeClass::execute(): arrived" << endl;
	Tango::DevUShort argin;
	extract(in_any, argin);
	((static_cast<KeithleyElectrometers *>(device))->set_range(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		GetModeClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetModeClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "GetModeClass::execute(): arrived" << endl;
	return insert((static_cast<KeithleyElectrometers *>(device))->get_mode());
}

//--------------------------------------------------------
/**
 * method : 		GetIntegrationTimeClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetIntegrationTimeClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "GetIntegrationTimeClass::execute(): arrived" << endl;
	return insert((static_cast<KeithleyElectrometers *>(device))->get_integration_time());
}

//--------------------------------------------------------
/**
 * method : 		SetIntegrationTimeClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *SetIntegrationTimeClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "SetIntegrationTimeClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	((static_cast<KeithleyElectrometers *>(device))->set_integration_time(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		VSourceOutputONClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *VSourceOutputONClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "VSourceOutputONClass::execute(): arrived" << endl;
	((static_cast<KeithleyElectrometers *>(device))->vsource_output_on());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		VSourceOutputOFFClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *VSourceOutputOFFClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "VSourceOutputOFFClass::execute(): arrived" << endl;
	((static_cast<KeithleyElectrometers *>(device))->vsource_output_off());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		SaveConfigurationClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *SaveConfigurationClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "SaveConfigurationClass::execute(): arrived" << endl;
	Tango::DevUShort argin;
	extract(in_any, argin);
	((static_cast<KeithleyElectrometers *>(device))->save_configuration(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		RestoreConfigurationClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *RestoreConfigurationClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "RestoreConfigurationClass::execute(): arrived" << endl;
	Tango::DevUShort argin;
	extract(in_any, argin);
	((static_cast<KeithleyElectrometers *>(device))->restore_configuration(argin));
	return new CORBA::Any();
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method      : KeithleyElectrometersClass::get_class_property()
 *	Description : Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum KeithleyElectrometersClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : KeithleyElectrometersClass::get_default_device_property()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum KeithleyElectrometersClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : KeithleyElectrometersClass::get_default_class_property()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum KeithleyElectrometersClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : KeithleyElectrometersClass::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void KeithleyElectrometersClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
	prop_name = "CommunicationLinkName";
	prop_desc = "The name of the device which manage the communication.";
	prop_def  = "WARN_no/communicationLinkName/defined";
	vect_data.clear();
	vect_data.push_back("WARN_no/communicationLinkName/defined");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "ElectrometerType";
	prop_desc = "The elctrometer type number.\n-> for 485 Keithley model : 485";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "UseMultiplexedChannels";
	prop_desc = "Set to true if a channel multiplexer is connected (such as a 6521 module option for 6517 Keithley device).";
	prop_def  = "False";
	vect_data.clear();
	vect_data.push_back("False");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "CreateDynamicVSourceAttribute";
	prop_desc = "Only for those models which support VSource output feature (as 6517).";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}

//--------------------------------------------------------
/**
 *	Method      : KeithleyElectrometersClass::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void KeithleyElectrometersClass::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("Keithley Electrometer");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("This class allows you to control all Keithley electrometers");
	str_desc.push_back("( with either DDC or SCPI commands ) through a GPIB.");
	str_desc.push_back("<br> Supported types :");
	str_desc.push_back("<br> Keithley Electrometers : DDC types -> 485, 486, 487, 617, 6512");
	str_desc.push_back("<br> Keithley Electrometers : SCPI types -> 6485, 6487, 6514, 6517");
	description << str_desc;
	data.push_back(description);

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method      : KeithleyElectrometersClass::device_factory()
 *	Description : Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void KeithleyElectrometersClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(KeithleyElectrometersClass::device_factory_before) ENABLED START -----*/
	
	//	Add your own code
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new KeithleyElectrometers(this, (*devlist_ptr)[i]));							 
	}

	//	Do not call erase: conflict with YAT dyn attrs -> device CRASH!!!
	// erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		KeithleyElectrometers *dev = static_cast<KeithleyElectrometers *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}
	
	return;
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometersClass::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new KeithleyElectrometers(this, (*devlist_ptr)[i]));
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		KeithleyElectrometers *dev = static_cast<KeithleyElectrometers *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(KeithleyElectrometersClass::device_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometersClass::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : KeithleyElectrometersClass::attribute_factory()
 *	Description : Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void KeithleyElectrometersClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(KeithleyElectrometersClass::attribute_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometersClass::attribute_factory_before
	//	Attribute : value
	valueAttrib	*value = new valueAttrib();
	Tango::UserDefaultAttrProp	value_prop;
	value_prop.set_description("Switch the selected mode it represents the value(s) returned in\n- amp if the AmpereMeter function is selected\n- volt in Volt Meter mode\n- ohm in Ohm Meter mode\n- coulomb in Coulomb Meter mode");
	value_prop.set_label("value");
	//	unit	not set for value
	//	standard_unit	not set for value
	//	display_unit	not set for value
	value_prop.set_format("%e");
	//	max_value	not set for value
	//	min_value	not set for value
	//	max_alarm	not set for value
	//	min_alarm	not set for value
	//	max_warning	not set for value
	//	min_warning	not set for value
	//	delta_t	not set for value
	//	delta_val	not set for value
	
	value->set_default_properties(value_prop);
	//	Not Polled
	value->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(value);

	//	Attribute : range
	rangeAttrib	*range = new rangeAttrib();
	Tango::UserDefaultAttrProp	range_prop;
	range_prop.set_description("Range of the selected mode");
	range_prop.set_label("range");
	//	unit	not set for range
	//	standard_unit	not set for range
	//	display_unit	not set for range
	range_prop.set_format("%4.2e");
	//	max_value	not set for range
	//	min_value	not set for range
	//	max_alarm	not set for range
	//	min_alarm	not set for range
	//	max_warning	not set for range
	//	min_warning	not set for range
	//	delta_t	not set for range
	//	delta_val	not set for range
	
	range->set_default_properties(range_prop);
	//	Not Polled
	range->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(range);

	//	Attribute : mode
	modeAttrib	*mode = new modeAttrib();
	Tango::UserDefaultAttrProp	mode_prop;
	mode_prop.set_description("The selected mode");
	mode_prop.set_label("mode");
	//	unit	not set for mode
	//	standard_unit	not set for mode
	//	display_unit	not set for mode
	mode_prop.set_format("%s");
	//	max_value	not set for mode
	//	min_value	not set for mode
	//	max_alarm	not set for mode
	//	min_alarm	not set for mode
	//	max_warning	not set for mode
	//	min_warning	not set for mode
	//	delta_t	not set for mode
	//	delta_val	not set for mode
	
	mode->set_default_properties(mode_prop);
	//	Not Polled
	mode->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(mode);

	//	Attribute : isAutoRangeOn
	isAutoRangeOnAttrib	*isautorangeon = new isAutoRangeOnAttrib();
	Tango::UserDefaultAttrProp	isautorangeon_prop;
	isautorangeon_prop.set_description("True if auto range ON.");
	isautorangeon_prop.set_label("is autorange on");
	//	unit	not set for isAutoRangeOn
	//	standard_unit	not set for isAutoRangeOn
	//	display_unit	not set for isAutoRangeOn
	isautorangeon_prop.set_format("%d");
	//	max_value	not set for isAutoRangeOn
	//	min_value	not set for isAutoRangeOn
	//	max_alarm	not set for isAutoRangeOn
	//	min_alarm	not set for isAutoRangeOn
	//	max_warning	not set for isAutoRangeOn
	//	min_warning	not set for isAutoRangeOn
	//	delta_t	not set for isAutoRangeOn
	//	delta_val	not set for isAutoRangeOn
	
	isautorangeon->set_default_properties(isautorangeon_prop);
	//	Not Polled
	isautorangeon->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(isautorangeon);

	//	Attribute : rangesList
	rangesListAttrib	*rangeslist = new rangesListAttrib();
	Tango::UserDefaultAttrProp	rangeslist_prop;
	rangeslist_prop.set_description("Ranges list of the selected mode");
	rangeslist_prop.set_label("ranges list");
	//	unit	not set for rangesList
	//	standard_unit	not set for rangesList
	//	display_unit	not set for rangesList
	rangeslist_prop.set_format("%s");
	//	max_value	not set for rangesList
	//	min_value	not set for rangesList
	//	max_alarm	not set for rangesList
	//	min_alarm	not set for rangesList
	//	max_warning	not set for rangesList
	//	min_warning	not set for rangesList
	//	delta_t	not set for rangesList
	//	delta_val	not set for rangesList
	
	rangeslist->set_default_properties(rangeslist_prop);
	//	Not Polled
	rangeslist->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(rangeslist);


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(KeithleyElectrometersClass::attribute_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometersClass::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : KeithleyElectrometersClass::pipe_factory()
 *	Description : Create the pipe object(s)
 *                and store them in the pipe list
 */
//--------------------------------------------------------
void KeithleyElectrometersClass::pipe_factory()
{
	/*----- PROTECTED REGION ID(KeithleyElectrometersClass::pipe_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometersClass::pipe_factory_before
	/*----- PROTECTED REGION ID(KeithleyElectrometersClass::pipe_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometersClass::pipe_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : KeithleyElectrometersClass::command_factory()
 *	Description : Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void KeithleyElectrometersClass::command_factory()
{
	/*----- PROTECTED REGION ID(KeithleyElectrometersClass::command_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometersClass::command_factory_before


	//	Command RangeUP
	RangeUPClass	*pRangeUPCmd =
		new RangeUPClass("RangeUP",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pRangeUPCmd);

	//	Command RangeDOWN
	RangeDOWNClass	*pRangeDOWNCmd =
		new RangeDOWNClass("RangeDOWN",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pRangeDOWNCmd);

	//	Command AutoRangeON
	AutoRangeONClass	*pAutoRangeONCmd =
		new AutoRangeONClass("AutoRangeON",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pAutoRangeONCmd);

	//	Command AutoRangeOFF
	AutoRangeOFFClass	*pAutoRangeOFFCmd =
		new AutoRangeOFFClass("AutoRangeOFF",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pAutoRangeOFFCmd);

	//	Command ZeroCheckON
	ZeroCheckONClass	*pZeroCheckONCmd =
		new ZeroCheckONClass("ZeroCheckON",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pZeroCheckONCmd);

	//	Command ZeroCheckOFF
	ZeroCheckOFFClass	*pZeroCheckOFFCmd =
		new ZeroCheckOFFClass("ZeroCheckOFF",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pZeroCheckOFFCmd);

	//	Command ZeroCorrectON
	ZeroCorrectONClass	*pZeroCorrectONCmd =
		new ZeroCorrectONClass("ZeroCorrectON",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pZeroCorrectONCmd);

	//	Command ZeroCorrectOFF
	ZeroCorrectOFFClass	*pZeroCorrectOFFCmd =
		new ZeroCorrectOFFClass("ZeroCorrectOFF",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pZeroCorrectOFFCmd);

	//	Command AutoZeroON
	AutoZeroONClass	*pAutoZeroONCmd =
		new AutoZeroONClass("AutoZeroON",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pAutoZeroONCmd);

	//	Command AutoZeroOFF
	AutoZeroOFFClass	*pAutoZeroOFFCmd =
		new AutoZeroOFFClass("AutoZeroOFF",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pAutoZeroOFFCmd);

	//	Command SetAmperMeterMode
	SetAmperMeterModeClass	*pSetAmperMeterModeCmd =
		new SetAmperMeterModeClass("SetAmperMeterMode",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pSetAmperMeterModeCmd);

	//	Command SetVoltMeterMode
	SetVoltMeterModeClass	*pSetVoltMeterModeCmd =
		new SetVoltMeterModeClass("SetVoltMeterMode",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pSetVoltMeterModeCmd);

	//	Command SetOhmMeterMode
	SetOhmMeterModeClass	*pSetOhmMeterModeCmd =
		new SetOhmMeterModeClass("SetOhmMeterMode",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pSetOhmMeterModeCmd);

	//	Command SetCoulombMeterMode
	SetCoulombMeterModeClass	*pSetCoulombMeterModeCmd =
		new SetCoulombMeterModeClass("SetCoulombMeterMode",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pSetCoulombMeterModeCmd);

	//	Command ClearRegisters
	ClearRegistersClass	*pClearRegistersCmd =
		new ClearRegistersClass("ClearRegisters",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pClearRegistersCmd);

	//	Command AverageStateON
	AverageStateONClass	*pAverageStateONCmd =
		new AverageStateONClass("AverageStateON",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pAverageStateONCmd);

	//	Command AverageStateOFF
	AverageStateOFFClass	*pAverageStateOFFCmd =
		new AverageStateOFFClass("AverageStateOFF",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pAverageStateOFFCmd);

	//	Command ClearBuffer
	ClearBufferClass	*pClearBufferCmd =
		new ClearBufferClass("ClearBuffer",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pClearBufferCmd);

	//	Command Start
	StartClass	*pStartCmd =
		new StartClass("Start",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pStartCmd);

	//	Command Reset
	ResetClass	*pResetCmd =
		new ResetClass("Reset",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pResetCmd);

	//	Command Abort
	AbortClass	*pAbortCmd =
		new AbortClass("Abort",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pAbortCmd);

	//	Command EnableSRQBufferFull
	EnableSRQBufferFullClass	*pEnableSRQBufferFullCmd =
		new EnableSRQBufferFullClass("EnableSRQBufferFull",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pEnableSRQBufferFullCmd);

	//	Command DisableSRQBufferFull
	DisableSRQBufferFullClass	*pDisableSRQBufferFullCmd =
		new DisableSRQBufferFullClass("DisableSRQBufferFull",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pDisableSRQBufferFullCmd);

	//	Command GetKeithleyConfig
	GetKeithleyConfigClass	*pGetKeithleyConfigCmd =
		new GetKeithleyConfigClass("GetKeithleyConfig",
			Tango::DEV_VOID, Tango::DEV_STRING,
			"no argin",
			"DDC Keithley configuration",
			Tango::OPERATOR);
	command_list.push_back(pGetKeithleyConfigCmd);

	//	Command GetRange
	GetRangeClass	*pGetRangeCmd =
		new GetRangeClass("GetRange",
			Tango::DEV_VOID, Tango::DEV_STRING,
			"no argin",
			"The electrometer range value",
			Tango::OPERATOR);
	command_list.push_back(pGetRangeCmd);

	//	Command SetRange
	SetRangeClass	*pSetRangeCmd =
		new SetRangeClass("SetRange",
			Tango::DEV_USHORT, Tango::DEV_VOID,
			"Index of the new range value to set (cf rangesList atrribute to get ranges indexes).",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pSetRangeCmd);

	//	Command GetMode
	GetModeClass	*pGetModeCmd =
		new GetModeClass("GetMode",
			Tango::DEV_VOID, Tango::DEV_STRING,
			"no argin",
			"The electrometer mode",
			Tango::OPERATOR);
	command_list.push_back(pGetModeCmd);

	//	Command GetIntegrationTime
	GetIntegrationTimeClass	*pGetIntegrationTimeCmd =
		new GetIntegrationTimeClass("GetIntegrationTime",
			Tango::DEV_VOID, Tango::DEV_DOUBLE,
			"no argin",
			"the integration time value",
			Tango::OPERATOR);
	command_list.push_back(pGetIntegrationTimeCmd);

	//	Command SetIntegrationTime
	SetIntegrationTimeClass	*pSetIntegrationTimeCmd =
		new SetIntegrationTimeClass("SetIntegrationTime",
			Tango::DEV_DOUBLE, Tango::DEV_VOID,
			"The integration time value (in seconds)",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pSetIntegrationTimeCmd);

	//	Command VSourceOutputON
	VSourceOutputONClass	*pVSourceOutputONCmd =
		new VSourceOutputONClass("VSourceOutputON",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pVSourceOutputONCmd);

	//	Command VSourceOutputOFF
	VSourceOutputOFFClass	*pVSourceOutputOFFCmd =
		new VSourceOutputOFFClass("VSourceOutputOFF",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pVSourceOutputOFFCmd);

	//	Command SaveConfiguration
	SaveConfigurationClass	*pSaveConfigurationCmd =
		new SaveConfigurationClass("SaveConfiguration",
			Tango::DEV_USHORT, Tango::DEV_VOID,
			"Configuration index number",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pSaveConfigurationCmd);

	//	Command RestoreConfiguration
	RestoreConfigurationClass	*pRestoreConfigurationCmd =
		new RestoreConfigurationClass("RestoreConfiguration",
			Tango::DEV_USHORT, Tango::DEV_VOID,
			"Configuration index to restore",
			"no argin",
			Tango::OPERATOR);
	command_list.push_back(pRestoreConfigurationCmd);

	/*----- PROTECTED REGION ID(KeithleyElectrometersClass::command_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometersClass::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		KeithleyElectrometersClass::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list
 */
//--------------------------------------------------------
void KeithleyElectrometersClass::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;

	/*----- PROTECTED REGION ID(KeithleyElectrometersClass::create_static_att_list) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometersClass::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		KeithleyElectrometersClass::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void KeithleyElectrometersClass::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		KeithleyElectrometers *dev = static_cast<KeithleyElectrometers *> (dev_impl);

		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(KeithleyElectrometersClass::erase_dynamic_attributes) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometersClass::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : KeithleyElectrometersClass::get_attr_object_by_name()
 *	Description : returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *KeithleyElectrometersClass::get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname)
{
	vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; ++it)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(KeithleyElectrometersClass::Additional Methods) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometersClass::Additional Methods
} //	namespace
